#property indicator_separate_window
#property indicator_buffers 4

#property indicator_color1 MediumPurple
#property indicator_color2 MediumPurple
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_level1 0

#property indicator_width3 1
#property indicator_width4 1


extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;

double MMACD1[];
double SMACD1[];
double MAX[];
double MIN[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init() {

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);

   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(2,119);
   SetIndexArrow(3,119);

   SetIndexDrawBegin(1,SMACD1);
   IndicatorDigits(Digits+2);

   SetIndexBuffer(0,MMACD1);
   SetIndexBuffer(1,SMACD1);
   SetIndexBuffer(2,MAX);
   SetIndexBuffer(3,MIN);

   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");
   SetIndexLabel(2,"MAX");
   SetIndexLabel(3,"MIN");

   return(0);
}
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence |
//+------------------------------------------------------------------+
int start() {
   int i, limit1, limit2;
   int counted_bars=IndicatorCounted();

   limit1=Bars-counted_bars-1;
   limit2=limit1;
   if (counted_bars==0) {
      limit1=Bars-MathMax(FastEMA,SlowEMA)-1;
      limit2=limit1-SignalSMA;
   }

   for(i=limit1; i>=0; i--)
      MMACD1[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

   for(i=limit2; i>=0; i--)
      SMACD1[i]=iMAOnArray(MMACD1,0,SignalSMA,0,MODE_SMA,i);

   for(i=limit2; i>=0; i--) { 
      MAX[i+1]=EMPTY_VALUE;
      MIN[i+1]=EMPTY_VALUE;
      
      if(MMACD1[i+1] > MMACD1[i+2])
         if (MMACD1[i+1] > MMACD1[i])
            MAX[i+1] = MMACD1[i+1];
      
      if(MMACD1[i+1] < MMACD1[i+2])
         if(MMACD1[i+1] < MMACD1[i])
            MIN[i+1] = MMACD1[i+1];
   }

   for(i=limit2; i>=0; i--) { 
      if (MAX[i+1] != EMPTY_VALUE) Print("MAX=",MAX[i+1]);
      if (MIN[i+1] != EMPTY_VALUE) Print("MIN=",MIN[i+1]);
   }

return(0);
}
//+------------------------------------------------------------------+

